stages: [build, deploy]

build:
  image: keymetrics/pm2:14-alpine
  stage: build
  script:
    - apk update && \
      apk upgrade && \
      apk add --no-cache \
      alpine-sdk \
      git \
      openssh \
      python3 \
      tzdata \
      build-base \
      libtool \
      autoconf \
      automake \
      gzip \
      g++ \
      make
    - npm i 
    - npm i -f @types/ws@8.5.4
    - npm run build
  only:
    - master
    
deploy:
  image: docker:24.0.6
  stage: deploy
  services:
    - docker:24.0.6-dind
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
    - docker build --pull -t "$CI_REGISTRY_IMAGE" .
    - docker push "$CI_REGISTRY_IMAGE"

  only:
    - master
